#define TINY_GSM_MODEM_SIM7600
#include <Arduino.h>
#include <PubSubClient.h>
#include <HardwareSerial.h>
#include <TinyGsmClient.h>
#include "TinyGsmTime.tpp"

HardwareSerial SerialAT(1);
HardwareSerial SerialSensor(2);

#define RXD1 26
#define TXD1 25

#define RXD2 16
#define TXD2 17


#define BUZZER 33
#define MODEM_POWER_ON 4
#define MODEM_KEY_ON 13
#define MODEM_STATUS 36
#define GSM_485_SELECTOR 14 // 0 = gsm , 1 485

TinyGsm modem1(SerialAT);
TinyGsm modem2(SerialAT);
TinyGsmClient gsmclient1(modem1);
TinyGsmClient gsmclient2(modem2);

const char apn[] = "internet";
const char gprsUser[] = "";
const char gprsPass[] = "";

int global_csq = 0;
String global_ccid = "";
String global_localip;
String global_imsi = "";

void PowerOnModem() {
  Serial.println("[Modem]  Power On Modem ");
  Serial.println("MODEM_POWER_ON ");
  digitalWrite(MODEM_POWER_ON, HIGH);
  delay(3000);
}

void EnableModem()
{
  Serial.println("8 Turn on Modem");
  PowerOnModem();
  delay(3000);
  // check press on , press off
  Serial.println("MODEM_KEY_ON ");
  Serial.print("MODEM_STATUS : ");
  Serial.println(digitalRead(MODEM_STATUS));
  if (digitalRead(MODEM_STATUS) == 1)
  {
    Serial.println("Press ...");
    digitalWrite(MODEM_KEY_ON, HIGH);
    delay(5000);
    digitalWrite(MODEM_KEY_ON, LOW);
  }
  else
  {
    Serial.println("Not Press ...");
  }
}


void debug_GSM() {

  Serial.println("debug_GSM()..");

  String imei = "";
  String imsi = "";
  int csq = 0;
  String ccid = "";
  IPAddress localip;
  String modemInfo;

  String modemName = modem1.getModemName();
  delay(500);
  Serial.println("Modem Name: " + modemName);

  modemInfo = modem1.getModemInfo();
  delay(2000);
  Serial.print("Modem Info: ");
  Serial.println(modemInfo);
  ccid = modem1.getSimCCID();
  // DBG("CCID:", ccid);
  Serial.print("[CCID: ] ");
  Serial.println(ccid);
  imei = modem1.getIMEI();
  // DBG("IMSI:", imsi);
  Serial.print("[IMEI: module ] ");
  Serial.println(imei);

  imsi = modem1.getIMSI();
  // DBG("IMSI:", imsi);
  Serial.print("[IMSI: sim] ");
  Serial.println(imsi);
  global_imsi = imsi;

  String cop = modem1.getOperator();
  // DBG("Operator:", cop);
  Serial.print("[Operator: ] ");
  Serial.println(cop);

  localip = modem1.localIP();
  // DBG("Local IP:", local);
  Serial.print("[Local IP: ] ");
  Serial.println(localip);
  global_localip = IpAddress2String(localip);
  // showip(localip.toString());
  csq = modem1.getSignalQuality();
  // DBG("Signal quality:", csq);
  Serial.print("[Signal quality: ] ");
  Serial.println(csq);
  global_csq = csq;
  Serial.println("+----------------------------------------+");
  // showcsq(csq);
}

void initModem() {

  Serial.println("[Modem] Initializing modem1, modem2...");

  if (!modem1.init()) {
    Serial.println("-Sorry :) Failed initial modem");
  }

  Serial.print("[Modem1]  Connecting to APN: ");
  Serial.println(apn);
  if (!modem1.gprsConnect(apn, gprsUser, gprsPass)) {
    Serial.println("Sorry fail");
  } else {
    Serial.println("Success OK");
  }

  if (!modem2.init()) {
    Serial.println("   Sorry :) Failed initial modem");
  }
  Serial.print("[Modem2]  Connecting to APN: ");
  Serial.print(apn);
  if (!modem2.gprsConnect(apn, gprsUser, gprsPass)) {
    Serial.println("fail");
  } else {
    Serial.println("OK");
  }

  debug_GSM();
}