/*
Scanning...
I2C device found at address 0x20  = MCP23017
I2C device found at address 0x27  = LCD
I2C device found at address 0x44  = SHT31 Temp
I2C device found at address 0x4A  = DFRobot Light
I2C device found at address 0x50  = EPROOM - AT24C64D  Atmel EEPROM 64K 
I2C device found at address 0x68  = DS3231 RTC
I2C device found at address 0x6E  = MCP3424 ADC

done

*/
#include <Wire.h>
 
void setup() {
  Wire.begin();
  Serial.begin(115200);
  Serial.println("\nI2C Scanner");
}
 
void loop() {
  byte error, address;
  int nDevices;
  Serial.println("Scanning...");
  nDevices = 0;
  for(address = 1; address < 127; address++ ) {
    Wire.beginTransmission(address);
    error = Wire.endTransmission();
    if (error == 0) {
      Serial.print("I2C device found at address 0x");
      if (address<16) {
        Serial.print("0");
      }
      Serial.println(address,HEX);
      nDevices++;
    }
    else if (error==4) {
      Serial.print("Unknow error at address 0x");
      if (address<16) {
        Serial.print("0");
      }
      Serial.println(address,HEX);
    }    
  }
  if (nDevices == 0) {
    Serial.println("No I2C devices found\n");
  }
  else {
    Serial.println("done\n");
  }
  delay(5000);          
}