#include <RTClib.h>
#include <TimeLib.h>
#include <TimeAlarms.h>


RTC_DS3231 rtc;

time_t time_provider()
{
    return rtc.now().unixtime();  
}

void reboot()
{
    ESP.restart();
}

void rtc_init(bool mode)
{
    Serial.println();
    Serial.println("[Setup] >>> rtc_setup Set time ");
    Wire.begin();
    rtc.begin();
    if (mode)
    {
      
      rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
      Serial.println("!!! Don't forget to change rtc_init(true) -> rtc_init(false)");
    }
    setSyncProvider(time_provider);
    Alarm.alarmRepeat(23, 00, 00, reboot);
}

void rtc_showtime()
{
    Serial.println();
    Serial.println("[Time] >>> rtc_showtime Show time ");
    DateTime nowRTC = rtc.now();
    time_t nowTime = nowRTC.unixtime();
    Serial.print("Display UnixTime : ");
    Serial.println(nowTime);
    Serial.print("Display yyyy/mm/dd hh:mm:ss : ");
    Serial.print(nowRTC.year(), DEC);
    Serial.print('/');
    Serial.print(nowRTC.month(), DEC);
    Serial.print('/');
    Serial.print(nowRTC.day(), DEC);
    Serial.print(' ');
    Serial.print(nowRTC.hour(), DEC);
    Serial.print(':');
    Serial.print(nowRTC.minute(), DEC);
    Serial.print(':');
    Serial.print(nowRTC.second(), DEC);
    Serial.println();

    // TimeLib.h function
    /*For Debugging*/
    Serial.print("TimeLib.h Time : ");
    Serial.print(hour());
    Serial.print(" : ");
    Serial.print(minute());
    Serial.print(" : ");
    Serial.println(second());
    Serial.print("TimeLib.h Date is: ");
    Serial.print(day());
    Serial.print(".");
    Serial.print(month());
    Serial.print(".");
    Serial.println(year());

    // Create string buffer
    char buffer[80];
    sprintf(buffer, "  %4d-%02d-%02d %02d:%02d:%02d", year(), month(), day(), hour(), minute(), second());
    Serial.print("Buffer String: ");
    Serial.println(buffer);
    delay(1000);
    Serial.println("");
}
